#pragma once
#include "Junction.h"
#include "Vector"

// 
#define AUTOMOBILE_STATE_RUN				0
#define AUTOMOBILE_STATE_WAIT_CAR			1
#define AUTOMOBILE_STATE_NEAR_JUNC			2
#define AUTOMOBILE_STATE_WAIT_CAR_NEAR_JUNC	3
#define AUTOMOBILE_STATE_WAIT_ON_JANC		4
#define AUTOMOBILE_STATE_TURN_LEFT			5
#define AUTOMOBILE_STATE_TURN_RIGHT			6
#define AUTOMOBILE_STATE_TURN_THROUGH		7

// 
#define EVENT_CLOCK							0

// 
#define DIRECTION_N							0
#define DIRECTION_E							1
#define DIRECTION_S							2
#define DIRECTION_W							3

#define DIRECTION_THROUGH					0
#define DIRECTION_RIGHT						1
#define DIRECTION_LEFT						2

class CAutomobile
{
public:
	int y0;

	bool x0(); //   
	bool x1(); //  
	bool x2(); //  ( )
    int x3(); //  
	bool x4(); //  
	bool x5(); //   
	bool x6(); //   

	void z0(); //  () 
	void z1(); //  dx
	void z2(); //   dx
	void z3(); //   
	void z4(); //  
	void z5(); //  
	void z6(); //  

	CString log[100];
	int currentLogString;

	int automobileModel;

	bool lights;

	int velociti;
	
	int startJunc;
	int endJunc;

	int oldDirection;

	int currentJunc;
	int turnDirection;
	int turnPosition;
	
	int distance;

	CPoint point;

	std::vector<CJunction> *juncs;
	std::vector<CAutomobile> *cars;

	CAutomobile(void);
	~CAutomobile(void);

	void Main(int event); 

	void Run();
	bool IsCarNear();
	bool IsJunction();
	bool IsJunctionNear();
	bool IsGreenLight();
	bool IsJuncFree();

	int GenerateTurnDirection();
	void SetDirection(int td);
	int GetDirection();
	int GetDirection(int sj, int ej);
	int GetTurnFromDirection(int d);


	typedef struct{
		int       dig;
		const char* n;
		const char* n_name;
	} int_str2_t;

	typedef struct{
		const char* n;
		const char* n_name;
	} str2_t;

	typedef struct{
		const char* n;
		const char* n_name;
		str2_t* str2;
	} str3_t;

	int_str2_t e_str2[1];

	str2_t x_str2[7];

	str2_t z_str2[7];

	str2_t a0_str2[8];

	str3_t A_str3[1];

	//---------------------------------------------------------------------------
	void log_a_begin(int y, int e)
	{
		log_a_begin_user(a0_str2[y].n, a0_str2[y].n_name);
	}
	//---------------------------------------------------------------------------
	void log_a_end(int y, int e)
	{
		log_a_end_user(a0_str2[y].n, a0_str2[y].n_name);
	}
	//---------------------------------------------------------------------------
	void log_x(int x, int res)
	{
		log_x_user(x_str2[x].n, x_str2[x].n_name, res);
	}
	//---------------------------------------------------------------------------
	void log_z(int z)
	{
		log_z_user(z_str2[z].n, z_str2[z].n_name);
	}
	//---------------------------------------------------------------------------
	void log_write(char ch, const char* str)
	{
		log_write_user(ch, str);
	}
	//---------------------------------------------------------------------------

	//---------------------------------------------------------------------------
	void log_a_begin_user(const char* y, const char* y_name)
	{
		// LOG_GRAPH_BEGIN 'a'('a_name'):   'y'()    'e'('e_name')

		currentLogString = (currentLogString + 1)%100;

		log[currentLogString] = ": ";
		log[currentLogString] += "  ";
		log[currentLogString] += y;
		log[currentLogString] += " (";
		log[currentLogString] += y_name;
		log[currentLogString] += ")    ";
		log[currentLogString] += "e0";
		log[currentLogString] += " (  dt)";
		log[currentLogString] += "\r\n";
	}
	void log_a_end_user(const char* y, const char* y_name)
	{
		// LOG_GRAPH_END 'a'('a_name'):    'e'('e_name')   'y'()

		currentLogString = (currentLogString + 1)%100;

		log[currentLogString] = ": ";
		log[currentLogString] += "   ";
		log[currentLogString] += "e0";
		log[currentLogString] += " (  dt) ";
		log[currentLogString] += "  ";
		log[currentLogString] += y;
		log[currentLogString] += " (";
		log[currentLogString] += y_name;
		log[currentLogString] += ")";
		log[currentLogString] += "\r\n";
	}
	//---------------------------------------------------------------------------
	void log_x_user(const char* x, const char* x_name, int res)
	{
		// LOG_X 'x' - 'x_name' -  'res'

		currentLogString = (currentLogString + 1)%100;

		log[currentLogString] = "    ";
		log[currentLogString] += x;
		log[currentLogString] += " - ";
		log[currentLogString] += x_name;
		log[currentLogString] += " -  ";
		log[currentLogString] += (char)(res + '0');
		log[currentLogString] += "\r\n";
	}
	//---------------------------------------------------------------------------
	void log_z_user(const char* z, const char* z_name)
	{
		// LOG_Z 'z' - 'z_name'

		currentLogString = (currentLogString + 1)%100;

		log[currentLogString] = "    ";
		log[currentLogString] += "    ";
		log[currentLogString] += z;
		log[currentLogString] += " - ";
		log[currentLogString] += z_name;
		log[currentLogString] += "\r\n";
	}
	//---------------------------------------------------------------------------
	void log_write_user(char ch, const char* str)
	{
		// ch, str

		currentLogString = (currentLogString + 1)%100;

		log[currentLogString] = ch;
		log[currentLogString] += " ";
		log[currentLogString] += str;
		log[currentLogString] += "\r\n";
	}
	//---------------------------------------------------------------------------
};
