// VehiclesView.cpp : implementation of the CVehiclesView class
//

#include "stdafx.h"
#include "Vehicles.h"
#include "MemDC.h"
#include "MainFrm.h"
#include "Math.h"

#include "VehiclesDoc.h"
#include "VehiclesView.h"
#include ".\vehiclesview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CVehiclesView

IMPLEMENT_DYNCREATE(CVehiclesView, CScrollView)

BEGIN_MESSAGE_MAP(CVehiclesView, CScrollView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	ON_WM_MOUSEMOVE()
	ON_COMMAND(ID_COMMAND_NEXT, OnCommandNext)
	ON_COMMAND(ID_COMMAND_PLAY, OnCommandPlay)
	ON_COMMAND(ID_COMMAND_STOP, OnCommandStop)
	ON_COMMAND(ID_LOG_SHOWLOG, OnLogShowlog)
	ON_COMMAND(ID_COMMAND_ADDCAR, OnCommandAddcar)
	ON_COMMAND(ID_COMMAND_REMOVECAR, OnCommandRemovecar)
	ON_COMMAND(ID_COMMAND_VIEWCARINFO, OnCommandViewcarinfo)
	ON_WM_SETCURSOR()
	ON_WM_LBUTTONDOWN()
END_MESSAGE_MAP()

// CVehiclesView construction/destruction

CVehiclesView::CVehiclesView()
{
	run = false;

	cursorMode = 0;
}

CVehiclesView::~CVehiclesView()
{
}

BOOL CVehiclesView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

// CVehiclesView drawing

void CVehiclesView::OnDraw(CDC* pDC)
{
	CVehiclesDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	CMemDC memDC(pDC);

	pDoc->world.OnDraw(&memDC);
}


// CVehiclesView printing

BOOL CVehiclesView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CVehiclesView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CVehiclesView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CVehiclesView diagnostics

#ifdef _DEBUG
void CVehiclesView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CVehiclesView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CVehiclesDoc* CVehiclesView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CVehiclesDoc)));
	return (CVehiclesDoc*)m_pDocument;
}
#endif //_DEBUG


// CVehiclesView message handlers

void CVehiclesView::OnTimer(UINT nIDEvent)
{
	CVehiclesDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	pDoc->world.OnTimer();
	Invalidate();

	/*	if(logDlg.m_hWnd)
	{
	logDlg.UpdateData(true);

	if(logDlg.car < 0)
	logDlg.car = 0;
	if(logDlg.car >= pDoc->world.automobiles.size())
	logDlg.car = pDoc->world.automobiles.size() - 1;

	logDlg.log = pDoc->world.automobiles[logDlg.car].log;
	logDlg.UpdateData(false);

	}*/

	CView::OnTimer(nIDEvent);
}

int CVehiclesView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;

	CVehiclesDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return 0;

	pDoc->world.Init("World.txt");

	return 0;
}

void CVehiclesView::OnDestroy()
{
	KillTimer(IDT_CLOCK);

	CView::OnDestroy();
}

BOOL CVehiclesView::OnEraseBkgnd(CDC* pDC)
{
	return 0;//CView::OnEraseBkgnd(pDC);
}

void CVehiclesView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CVehiclesDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CSize sizeTotal = pDoc->world.GetBitmapSize(&pDoc->world.map);

	SetScrollSizes(MM_TEXT, sizeTotal);
}

void CVehiclesView::OnMouseMove(UINT nFlags, CPoint point)
{
	char mes[100];

	sprintf(mes,"X %d  Y %d",point.x,point.y);

	CMainFrame *cm;
	cm = STATIC_DOWNCAST(CMainFrame,AfxGetMainWnd());
	cm->m_wndStatusBar.SetWindowText(mes);

	CScrollView::OnMouseMove(nFlags, point);
}

void CVehiclesView::OnCommandNext()
{
	// TODO: Add your command handler code here
}

void CVehiclesView::OnCommandPlay()
{
	if(!run)
	{
		SetTimer(IDT_CLOCK, 50, 0);
		run = true;
	}
}

void CVehiclesView::OnCommandStop()
{
	if(run)
	{
		KillTimer(IDT_CLOCK);
		run = false;
	}
}

void CVehiclesView::OnLogShowlog()
{
	CVehiclesDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	if(run)
	{
		KillTimer(IDT_CLOCK);
		run = false;
	}

	//	logDlg.DestroyWindow();

	logDlg.car = 0;

	logDlg.log = "";

	for(int i = (pDoc->world.automobiles[0].currentLogString + 1)%100; i != pDoc->world.automobiles[0].currentLogString; i = (i+1)%100)
		logDlg.log += pDoc->world.automobiles[0].log[i];

	logDlg.log += pDoc->world.automobiles[0].log[pDoc->world.automobiles[0].currentLogString];

	logDlg.DoModal();

	//	logDlg.Create(IDD_LOG_DIALOG, this);
}
void CVehiclesView::OnCommandAddcar()
{
	CMainFrame *pMainFrm = (CMainFrame *)AfxGetApp()->m_pMainWnd;

	if(cursorMode != 1)
	{
		cursorMode = 1;

		pMainFrm->GetMenu()->CheckMenuItem(ID_COMMAND_ADDCAR,MF_CHECKED); 
		pMainFrm->m_wndToolBar.SetButtonStyle(pMainFrm->m_wndToolBar.CommandToIndex(ID_COMMAND_ADDCAR), TBBS_CHECKED);

		pMainFrm->GetMenu()->CheckMenuItem(ID_COMMAND_REMOVECAR,MF_UNCHECKED); 
		pMainFrm->m_wndToolBar.SetButtonStyle(pMainFrm->m_wndToolBar.CommandToIndex(ID_COMMAND_REMOVECAR), TBBS_BUTTON);

		pMainFrm->GetMenu()->CheckMenuItem(ID_COMMAND_VIEWCARINFO,MF_UNCHECKED); 
		pMainFrm->m_wndToolBar.SetButtonStyle(pMainFrm->m_wndToolBar.CommandToIndex(ID_COMMAND_VIEWCARINFO), TBBS_BUTTON);
	}
	else
	{
		pMainFrm->GetMenu()->CheckMenuItem(ID_COMMAND_ADDCAR,MF_UNCHECKED); 
		pMainFrm->m_wndToolBar.SetButtonStyle(pMainFrm->m_wndToolBar.CommandToIndex(ID_COMMAND_ADDCAR), TBBS_BUTTON);

		cursorMode = 0;
	}
}

void CVehiclesView::OnCommandRemovecar()
{
	CMainFrame *pMainFrm = (CMainFrame *)AfxGetApp()->m_pMainWnd;

	if(cursorMode != 2)
	{
		cursorMode = 2;

		pMainFrm->GetMenu()->CheckMenuItem(ID_COMMAND_REMOVECAR,MF_CHECKED); 
		pMainFrm->m_wndToolBar.SetButtonStyle(pMainFrm->m_wndToolBar.CommandToIndex(ID_COMMAND_REMOVECAR), TBBS_CHECKED);

		pMainFrm->GetMenu()->CheckMenuItem(ID_COMMAND_ADDCAR,MF_UNCHECKED); 
		pMainFrm->m_wndToolBar.SetButtonStyle(pMainFrm->m_wndToolBar.CommandToIndex(ID_COMMAND_ADDCAR), TBBS_BUTTON);

		pMainFrm->GetMenu()->CheckMenuItem(ID_COMMAND_VIEWCARINFO,MF_UNCHECKED); 
		pMainFrm->m_wndToolBar.SetButtonStyle(pMainFrm->m_wndToolBar.CommandToIndex(ID_COMMAND_VIEWCARINFO), TBBS_BUTTON);
	}
	else
	{
		pMainFrm->GetMenu()->CheckMenuItem(ID_COMMAND_REMOVECAR,MF_UNCHECKED); 
		pMainFrm->m_wndToolBar.SetButtonStyle(pMainFrm->m_wndToolBar.CommandToIndex(ID_COMMAND_REMOVECAR), TBBS_BUTTON);

		cursorMode = 0;
	}
}

void CVehiclesView::OnCommandViewcarinfo()
{
	CMainFrame *pMainFrm = (CMainFrame *)AfxGetApp()->m_pMainWnd;

	if(cursorMode != 3)
	{
		cursorMode = 3;

		pMainFrm->GetMenu()->CheckMenuItem(ID_COMMAND_VIEWCARINFO,MF_CHECKED); 
		pMainFrm->m_wndToolBar.SetButtonStyle(pMainFrm->m_wndToolBar.CommandToIndex(ID_COMMAND_VIEWCARINFO), TBBS_CHECKED);

		pMainFrm->GetMenu()->CheckMenuItem(ID_COMMAND_REMOVECAR,MF_UNCHECKED); 
		pMainFrm->m_wndToolBar.SetButtonStyle(pMainFrm->m_wndToolBar.CommandToIndex(ID_COMMAND_REMOVECAR), TBBS_BUTTON);

		pMainFrm->GetMenu()->CheckMenuItem(ID_COMMAND_ADDCAR,MF_UNCHECKED); 
		pMainFrm->m_wndToolBar.SetButtonStyle(pMainFrm->m_wndToolBar.CommandToIndex(ID_COMMAND_ADDCAR), TBBS_BUTTON);
	}
	else
	{
		pMainFrm->GetMenu()->CheckMenuItem(ID_COMMAND_VIEWCARINFO,MF_UNCHECKED); 
		pMainFrm->m_wndToolBar.SetButtonStyle(pMainFrm->m_wndToolBar.CommandToIndex(ID_COMMAND_VIEWCARINFO), TBBS_BUTTON);

		cursorMode = 0;
	}
}


BOOL CVehiclesView::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	if(cursorMode == 1)
	{
		SetCursor(AfxGetApp()->LoadCursor(IDC_POINTER_ADD));
		return TRUE;
	}		
	if(cursorMode == 2)
	{
		SetCursor(AfxGetApp()->LoadCursor(IDC_POINTER_REMOVE));
		return TRUE;
	}		
	if(cursorMode == 3)
	{
		SetCursor(AfxGetApp()->LoadCursor(IDC_POINTER_INFO));
		return TRUE;
	}		

	SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
	return TRUE;
}

void CVehiclesView::OnLButtonDown(UINT nFlags, CPoint point)
{
	CVehiclesDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	point.x += GetScrollPos(0);
	point.y += GetScrollPos(1);


	if(cursorMode == 2)
	{
		int size =  pDoc->world.automobiles.size();
		for(int i = 0; i < size; i++)
		{
			CPoint carPoint = pDoc->world.automobiles[i].point;
			if(sqrt((double)(carPoint.x - point.x)*(carPoint.x - point.x) + (carPoint.y - point.y)*(carPoint.y - point.y)) < 25)
			{
				std::vector<CAutomobile> newcars;
				for(int j = 0; j < size; j++)
				{
					if(i != j)
						newcars.push_back(pDoc->world.automobiles[j]);
				}
				pDoc->world.automobiles.clear();

				pDoc->world.automobiles = newcars;

				Invalidate(false);

				return;
			}
		}
	}

	if(cursorMode == 3)
	{
		int size =  pDoc->world.automobiles.size();
		for(int i = 0; i < size; i++)
		{
			CPoint carPoint = pDoc->world.automobiles[i].point;
			if(sqrt((double)(carPoint.x - point.x)*(carPoint.x - point.x) + (carPoint.y - point.y)*(carPoint.y - point.y)) < 25)
			{
				if(run)
				{
					KillTimer(IDT_CLOCK);
					run = false;
				}

				//	logDlg.DestroyWindow();

				logDlg.car = i;

				logDlg.log = "";

				for(int j = (pDoc->world.automobiles[i].currentLogString + 1)%100; j != pDoc->world.automobiles[i].currentLogString; j = (j+1)%100)
					logDlg.log += pDoc->world.automobiles[i].log[j];

				logDlg.log += pDoc->world.automobiles[i].log[pDoc->world.automobiles[i].currentLogString];

				logDlg.DoModal();	
				return;
			}
		}
	}

	if(cursorMode == 1)
	{
		int size =  pDoc->world.juncs.size();
		for(int i = 0; i < size; i++)
		{
			CPoint jancPoint;
			jancPoint.x = pDoc->world.juncs[i].x;
			jancPoint.y = pDoc->world.juncs[i].y;
			if(sqrt((double)(jancPoint.x - point.x)*(jancPoint.x - point.x) + (jancPoint.y - point.y)*(jancPoint.y - point.y)) < 25)
			{
				CAutomobile a;
				a.automobileModel = 0;
				a.velociti = 3;
				a.distance = 60;
				a.startJunc = i;

				for(int k = 0; k < 4; k++)
				{
					if(pDoc->world.juncs[i].neighbours[k] != -1)
					{
						a.endJunc = pDoc->world.juncs[i].neighbours[k];
					}
				}

				a.juncs = &pDoc->world.juncs;
				a.cars = &pDoc->world.automobiles;
				a.y0 = AUTOMOBILE_STATE_RUN;

				pDoc->world.automobiles.resize(pDoc->world.automobiles.size()+1, a);
					
				Invalidate(false);

				return;
			}
		}
	}




	CScrollView::OnLButtonDown(nFlags, point);
}
